#ifndef AIM__AIM_H
#define AIM__AIM_H

#include <ppm.h>
#include <stdbool.h>

struct image {
	int cols, rows;
	pixval maxval;
	/* Black-white image, one _BIT_ per pixel. Rows-oriented,
	 * rows are rounded to whole bytes. */
	pixval *bitmap;
};

static int image_rowbytes(struct image *img);
static void image_getpixel(struct image *img, int x, int y, pixval *r, pixval *g, pixval *b);
static void image_putpixel(struct image *img, int x, int y, pixval r, pixval g, pixval b);

void exercise(struct image * restrict in, struct image * restrict out);


/** Implementation: */

static inline int
image_rowbytes(struct image *img)
{
	return img->cols * 3;
}

static inline void
image_getpixel(struct image *img, int x, int y, pixval *r, pixval *g, pixval *b)
{
	*r = img->bitmap[image_rowbytes(img) * y + x*3 + 0];
	*g = img->bitmap[image_rowbytes(img) * y + x*3 + 1];
	*b = img->bitmap[image_rowbytes(img) * y + x*3 + 2];
}

static inline void
image_putpixel(struct image *img, int x, int y, pixval r, pixval g, pixval b)
{
	img->bitmap[image_rowbytes(img) * y + x*3 + 0] = r;
	img->bitmap[image_rowbytes(img) * y + x*3 + 1] = g;
	img->bitmap[image_rowbytes(img) * y + x*3 + 2] = b;
}

#endif
